Blame SOURCES/cryptsetup-2.5.0-Remove-LUKS2-encryption-data-size-restriction.patch

5c2830
From 6bc1378ddb5bbcc6ba592177c996576b0b3505f9 Mon Sep 17 00:00:00 2001
5c2830
From: Ondrej Kozina <okozina@redhat.com>
5c2830
Date: Fri, 22 Oct 2021 13:06:48 +0200
5c2830
Subject: [PATCH] Remove LUKS2 encryption data size restriction.
5c2830
5c2830
LUKS2 encryption with data shift required remaining
5c2830
data size (size remaining after substracting --reduce-data-size value)
5c2830
to be at least --reduce-data-size. This was wrong. Remaining
5c2830
data size restriction should be correctly at least single sector
5c2830
(whatever sector size is selected or auto-detected).
5c2830
---
5c2830
 lib/luks2/luks2_reencrypt.c   | 31 ++++++++++++-----------
5c2830
 tests/api-test-2.c            |  6 ++---
5c2830
 tests/luks2-reencryption-test | 46 +++++++++++++++++++++++++++++------
5c2830
 3 files changed, 57 insertions(+), 26 deletions(-)
5c2830
5c2830
diff --git a/lib/luks2/luks2_reencrypt.c b/lib/luks2/luks2_reencrypt.c
5c2830
index b45327ad..d0e0dc40 100644
5c2830
--- a/lib/luks2/luks2_reencrypt.c
5c2830
+++ b/lib/luks2/luks2_reencrypt.c
5c2830
@@ -825,7 +825,7 @@ static int reencrypt_offset_backward_moved(struct luks2_hdr *hdr, json_object *j
5c2830
 			linear_length += LUKS2_segment_size(hdr, sg, 0);
5c2830
 
5c2830
 	/* all active linear segments length */
5c2830
-	if (linear_length) {
5c2830
+	if (linear_length && segs > 1) {
5c2830
 		if (linear_length < data_shift)
5c2830
 			return -EINVAL;
5c2830
 		tmp = linear_length - data_shift;
5c2830
@@ -1745,7 +1745,8 @@ static int reencrypt_set_encrypt_segments(struct crypt_device *cd, struct luks2_
5c2830
 	int r;
5c2830
 	uint64_t first_segment_offset, first_segment_length,
5c2830
 		 second_segment_offset, second_segment_length,
5c2830
-		 data_offset = LUKS2_get_data_offset(hdr) << SECTOR_SHIFT;
5c2830
+		 data_offset = LUKS2_get_data_offset(hdr) << SECTOR_SHIFT,
5c2830
+		 data_size = dev_size - data_shift;
5c2830
 	json_object *jobj_segment_first = NULL, *jobj_segment_second = NULL, *jobj_segments;
5c2830
 
5c2830
 	if (dev_size < data_shift)
5c2830
@@ -1760,9 +1761,14 @@ static int reencrypt_set_encrypt_segments(struct crypt_device *cd, struct luks2_
5c2830
 		 * [future LUKS2 header (data shift size)][second data segment][gap (data shift size)][first data segment (data shift size)]
5c2830
 		 */
5c2830
 		first_segment_offset = dev_size;
5c2830
-		first_segment_length = data_shift;
5c2830
-		second_segment_offset = data_shift;
5c2830
-		second_segment_length = dev_size - 2 * data_shift;
5c2830
+		if (data_size < data_shift) {
5c2830
+			first_segment_length = data_size;
5c2830
+			second_segment_length = second_segment_offset = 0;
5c2830
+		} else {
5c2830
+			first_segment_length = data_shift;
5c2830
+			second_segment_offset = data_shift;
5c2830
+			second_segment_length = data_size - data_shift;
5c2830
+		}
5c2830
 	} else if (data_shift) {
5c2830
 		first_segment_offset = data_offset;
5c2830
 		first_segment_length = dev_size;
5c2830
@@ -2163,17 +2169,10 @@ static int reencrypt_move_data(struct crypt_device *cd, int devfd, uint64_t data
5c2830
 
5c2830
 	log_dbg(cd, "Going to move data from head of data device.");
5c2830
 
5c2830
-	buffer_len = data_shift;
5c2830
-	if (!buffer_len)
5c2830
-		return -EINVAL;
5c2830
-
5c2830
 	offset = json_segment_get_offset(LUKS2_get_segment_jobj(hdr, 0), 0);
5c2830
-
5c2830
-	/* this is nonsense anyway */
5c2830
-	if (buffer_len != json_segment_get_size(LUKS2_get_segment_jobj(hdr, 0), 0)) {
5c2830
-		log_dbg(cd, "buffer_len %" PRIu64", segment size %" PRIu64, buffer_len, json_segment_get_size(LUKS2_get_segment_jobj(hdr, 0), 0));
5c2830
+	buffer_len = json_segment_get_size(LUKS2_get_segment_jobj(hdr, 0), 0);
5c2830
+	if (!buffer_len || buffer_len > data_shift)
5c2830
 		return -EINVAL;
5c2830
-	}
5c2830
 
5c2830
 	if (posix_memalign(&buffer, device_alignment(crypt_data_device(cd)), buffer_len))
5c2830
 		return -ENOMEM;
5c2830
@@ -2447,7 +2446,7 @@ static int reencrypt_init(struct crypt_device *cd,
5c2830
 	 * encryption initialization (or mount)
5c2830
 	 */
5c2830
 	if (move_first_segment) {
5c2830
-		if (dev_size < 2 * (params->data_shift << SECTOR_SHIFT)) {
5c2830
+		if (dev_size < (params->data_shift << SECTOR_SHIFT)) {
5c2830
 			log_err(cd, _("Device %s is too small."), device_path(crypt_data_device(cd)));
5c2830
 			return -EINVAL;
5c2830
 		}
5c2830
@@ -3484,7 +3483,7 @@ int LUKS2_reencrypt_check_device_size(struct crypt_device *cd, struct luks2_hdr
5c2830
 		    check_size, check_size >> SECTOR_SHIFT, real_size, real_size >> SECTOR_SHIFT,
5c2830
 		    real_size - data_offset, (real_size - data_offset) >> SECTOR_SHIFT);
5c2830
 
5c2830
-	if (real_size < data_offset || (check_size && (real_size - data_offset) < check_size)) {
5c2830
+	if (real_size < data_offset || (check_size && real_size < check_size)) {
5c2830
 		log_err(cd, _("Device %s is too small."), device_path(crypt_data_device(cd)));
5c2830
 		return -EINVAL;
5c2830
 	}
5c2830
diff --git a/tests/api-test-2.c b/tests/api-test-2.c
5c2830
index a01a7a72..05ee8f94 100644
5c2830
--- a/tests/api-test-2.c
5c2830
+++ b/tests/api-test-2.c
5c2830
@@ -4238,7 +4238,7 @@ static void Luks2Reencryption(void)
5c2830
 
5c2830
 	_cleanup_dmdevices();
5c2830
 	OK_(create_dmdevice_over_loop(H_DEVICE, r_header_size));
5c2830
-	OK_(create_dmdevice_over_loop(L_DEVICE_OK, 12*1024*2+1));
5c2830
+	OK_(create_dmdevice_over_loop(L_DEVICE_OK, 8*1024*2+1));
5c2830
 
5c2830
 	/* encryption with datashift and moved segment (data shift + 1 sector) */
5c2830
 	OK_(crypt_init(&cd, DMDIR H_DEVICE));
5c2830
@@ -4258,11 +4258,11 @@ static void Luks2Reencryption(void)
5c2830
 
5c2830
 	_cleanup_dmdevices();
5c2830
 	OK_(create_dmdevice_over_loop(H_DEVICE, r_header_size));
5c2830
-	OK_(create_dmdevice_over_loop(L_DEVICE_OK, 12*1024*2));
5c2830
+	OK_(create_dmdevice_over_loop(L_DEVICE_OK, 2*8200));
5c2830
 
5c2830
 	OK_(crypt_init(&cd, DMDIR H_DEVICE));
5c2830
 
5c2830
-	/* encryption with datashift and moved segment (data shift + data offset > device size) */
5c2830
+	/* encryption with datashift and moved segment (data shift + data offset <= device size) */
5c2830
 	memset(&rparams, 0, sizeof(rparams));
5c2830
 	params2.sector_size = 512;
5c2830
 	params2.data_device = DMDIR L_DEVICE_OK;
5c2830
diff --git a/tests/luks2-reencryption-test b/tests/luks2-reencryption-test
5c2830
index 8efb2707..bf711c15 100755
5c2830
--- a/tests/luks2-reencryption-test
5c2830
+++ b/tests/luks2-reencryption-test
5c2830
@@ -152,14 +152,30 @@ function open_crypt() # $1 pwd, $2 hdr
5c2830
 	fi
5c2830
 }
5c2830
 
5c2830
+function wipe_dev_head() # $1 dev, $2 length (in MiBs)
5c2830
+{
5c2830
+	dd if=/dev/zero of=$1 bs=1M count=$2 conv=notrunc >/dev/null 2>&1
5c2830
+}
5c2830
+
5c2830
 function wipe_dev() # $1 dev
5c2830
 {
5c2830
 	if [ -b $1 ] ; then
5c2830
 		blkdiscard --zeroout $1 2>/dev/null || dd if=/dev/zero of=$1 bs=1M conv=notrunc >/dev/null 2>&1
5c2830
+		if [ $# -gt 2 ]; then
5c2830
+			dd if=/dev/urandom of=$1 bs=1M seek=$2 conv=notrunc >/dev/null 2>&1
5c2830
+		fi
5c2830
 	else
5c2830
 		local size=$(stat --printf="%s" $1)
5c2830
 		truncate -s 0 $1
5c2830
-		truncate -s $size $1
5c2830
+		if [ $# -gt 2 ]; then
5c2830
+			local diff=$((size-$2*1024*1024))
5c2830
+			echo "size: $size, diff: $diff"
5c2830
+			truncate -s $diff $1
5c2830
+			# wipe_dev_head $1 $((diff/(1024*1024)))
5c2830
+			dd if=/dev/urandom of=$1 bs=1M seek=$2 size=$((diff/(1024*1024))) conv=notrunc >/dev/null 2>&1
5c2830
+		else
5c2830
+			truncate -s $size $1
5c2830
+		fi
5c2830
 	fi
5c2830
 }
5c2830
 
5c2830
@@ -214,15 +230,16 @@ function check_hash() # $1 pwd, $2 hash, $3 hdr
5c2830
 	$CRYPTSETUP remove $DEV_NAME || fail
5c2830
 }
5c2830
 
5c2830
+function check_hash_dev_head() # $1 dev, $2 len, $3 hash
5c2830
+{
5c2830
+	local hash=$(dd if=$1 bs=512 count=$2 2>/dev/null | sha256sum | cut -d' ' -f1)
5c2830
+	[ $hash != "$3" ] && fail "HASH differs (expected: $3) (result $hash)"
5c2830
+}
5c2830
+
5c2830
 function check_hash_head() # $1 pwd, $2 len, $3 hash, $4 hdr
5c2830
 {
5c2830
 	open_crypt $1 $4
5c2830
-	if [ -n "$4" ]; then
5c2830
-		echo $1 | $CRYPTSETUP resize $DEV_NAME --size $2 --header $4 || fail
5c2830
-	else
5c2830
-		echo $1 | $CRYPTSETUP resize $DEV_NAME --size $2 || fail
5c2830
-	fi
5c2830
-	check_hash_dev /dev/mapper/$DEV_NAME $3
5c2830
+	check_hash_dev_head /dev/mapper/$DEV_NAME $2 $3
5c2830
 	$CRYPTSETUP remove $DEV_NAME || fail
5c2830
 }
5c2830
 
5c2830
@@ -865,6 +882,21 @@ $CRYPTSETUP status $DEV_NAME >/dev/null 2>&1 || fail
5c2830
 $CRYPTSETUP close $DEV_NAME
5c2830
 echo $PWD1 | $CRYPTSETUP open $DEV --test-passphrase || fail
5c2830
 
5c2830
+# Small device encryption test
5c2830
+preparebig 65
5c2830
+# wipe only 1st MiB (final data size after encryption)
5c2830
+wipe_dev $DEV 1
5c2830
+check_hash_dev_head $DEV 2048 $HASH2
5c2830
+echo $PWD1 | $CRYPTSETUP reencrypt $DEV --encrypt --reduce-device-size 64M -q $FAST_PBKDF_ARGON || fail
5c2830
+check_hash_head $PWD1 2048 $HASH2
5c2830
+
5c2830
+wipe_dev_head $DEV 1
5c2830
+check_hash_dev_head $DEV 2048 $HASH2
5c2830
+echo $PWD1 | $CRYPTSETUP reencrypt $DEV --encrypt --reduce-device-size 64M --init-only -q $FAST_PBKDF_ARGON $DEV_NAME >/dev/null || fail
5c2830
+check_hash_dev_head /dev/mapper/$DEV_NAME 2048 $HASH2
5c2830
+echo $PWD1 | $CRYPTSETUP reencrypt $DEV -q || fail
5c2830
+check_hash_dev_head /dev/mapper/$DEV_NAME 2048 $HASH2
5c2830
+
5c2830
 echo "[3] Encryption with detached header"
5c2830
 preparebig 256
5c2830
 wipe_dev $DEV
5c2830
-- 
5c2830
2.38.1
5c2830